'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('@material-ui/core/styles');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Appbar = require('../Appbar/Appbar');

var _Appbar2 = _interopRequireDefault(_Appbar);

var _Sidebar = require('../Sidebar/Sidebar');

var _Sidebar2 = _interopRequireDefault(_Sidebar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var drawerWidth = 240;

var styles = function styles(theme) {
    return {
        root: {
            flexGrow: 1
        },
        appFrame: {
            minHeight: '100vh',
            zIndex: 1,
            overflow: 'hidden',
            position: 'relative',
            display: 'flex',
            width: '100%'
        },
        drawerHeader: (0, _extends3.default)({
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'flex-end',
            padding: '0 8px'
        }, theme.mixins.toolbar),
        appBar: {
            position: 'absolute',
            transition: theme.transitions.create(['margin', 'width'], {
                easing: theme.transitions.easing.sharp,
                duration: theme.transitions.duration.leavingScreen
            })
        },
        appBarShift: {
            width: 'calc(100% - ' + drawerWidth + 'px)',
            transition: theme.transitions.create(['margin', 'width'], {
                easing: theme.transitions.easing.easeOut,
                duration: theme.transitions.duration.enteringScreen
            }),
            marginLeft: drawerWidth
        },
        content: {
            flexGrow: 1,
            boxSizing: 'border-box',
            backgroundColor: theme.palette.background.default,
            padding: theme.spacing.unit * 3,
            transition: theme.transitions.create('margin', {
                easing: theme.transitions.easing.sharp,
                duration: theme.transitions.duration.leavingScreen
            }),
            marginLeft: -drawerWidth,
            width: '100%'
        },
        contentShift: {
            transition: theme.transitions.create('margin', {
                easing: theme.transitions.easing.easeOut,
                duration: theme.transitions.duration.enteringScreen
            }),
            width: 'calc(100% - ' + drawerWidth + 'px)',
            marginLeft: 0
        }
    };
};

var AppLayout = function (_Component) {
    (0, _inherits3.default)(AppLayout, _Component);

    function AppLayout() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, AppLayout);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AppLayout.__proto__ || (0, _getPrototypeOf2.default)(AppLayout)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            menuOpen: false,
            pinMenu: true
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(AppLayout, [{
        key: 'toggleMenu',
        value: function toggleMenu(value) {
            this.setState(function (s) {
                return {
                    menuOpen: value === true ? true : value === false ? false : !s.menuOpen
                };
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                title = _props.title,
                classes = _props.classes,
                children = _props.children,
                menuTop = _props.menuTop,
                menuPrimary = _props.menuPrimary,
                menuSecondary = _props.menuSecondary;
            var menuOpen = this.state.menuOpen;


            return _react2.default.createElement(
                'div',
                { className: classes.root },
                _react2.default.createElement(_Appbar2.default, {
                    className: (0, _classnames2.default)(classes.appBar, (0, _defineProperty3.default)({}, classes.appBarShift, menuOpen)),
                    menuItems: menuTop,
                    title: title,
                    onToggleSidebar: this.toggleMenu.bind(this)
                }),
                _react2.default.createElement(
                    'div',
                    { className: classes.appFrame },
                    _react2.default.createElement(_Sidebar2.default, {
                        onCloseSidebar: function onCloseSidebar() {
                            return _this2.toggleMenu(false);
                        },
                        open: menuOpen,
                        primaryItems: menuPrimary,
                        secondaryItems: menuSecondary
                    }),
                    _react2.default.createElement(
                        'main',
                        { className: (0, _classnames2.default)(classes.content, (0, _defineProperty3.default)({}, classes.contentShift, menuOpen)) },
                        _react2.default.createElement('div', { className: classes.drawerHeader }),
                        children
                    )
                )
            );
        }
    }]);
    return AppLayout;
}(_react.Component);

AppLayout.propTypes = {
    classes: _propTypes2.default.object.isRequired
};

exports.default = (0, _styles.withStyles)(styles)(AppLayout);