'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('@material-ui/core/styles');

var _core = require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
    root: {
        flexGrow: 1
    },
    flex: {
        flex: 1
    },
    menuButton: {
        marginLeft: -12,
        marginRight: 20
    }
};

var Appbar = function Appbar(_ref) {
    var className = _ref.className,
        classes = _ref.classes,
        title = _ref.title,
        menuItems = _ref.menuItems,
        onToggleSidebar = _ref.onToggleSidebar;
    return _react2.default.createElement(
        _core.AppBar,
        { className: className },
        _react2.default.createElement(
            _core.Toolbar,
            null,
            _react2.default.createElement(
                _core.IconButton,
                { className: classes.menuButton, color: 'inherit', 'aria-label': 'Menu', onClick: onToggleSidebar },
                _react2.default.createElement(
                    _core.Icon,
                    null,
                    'menu'
                )
            ),
            _react2.default.createElement(
                _core.Typography,
                { variant: 'title', color: 'inherit', noWrap: true, className: classes.flex },
                title
            ),
            menuItems.map(function (item, i) {
                return _react2.default.isValidElement(item) ? item : _react2.default.createElement(
                    _core.Button,
                    { key: i, color: 'inherit', onClick: item.onClick, href: item.href },
                    item.label
                );
            })
        )
    );
};

Appbar.propTypes = {
    classes: _propTypes2.default.any, // ?
    title: _propTypes2.default.node,
    menuItems: _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.shape({
        label: _propTypes2.default.node.isRequired,
        onClick: _propTypes2.default.func,
        href: _propTypes2.default.string
    })]))
};

exports.default = (0, _styles.withStyles)(styles)(Appbar);