'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _core = require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CheckboxOrSwitch = function CheckboxOrSwitch(_ref) {
    var color = _ref.color,
        disabled = _ref.disabled,
        id = _ref.id,
        inputProps = _ref.inputProps,
        label = _ref.label,
        margin = _ref.margin,
        name = _ref.name,
        nativeInputProps = _ref.nativeInputProps,
        onChange = _ref.onChange,
        option = _ref.option,
        required = _ref.required,
        multiple = _ref.multiple,
        type = _ref.type,
        value = _ref.value,
        wrapped = _ref.wrapped;


    var SwitchOrCheckbox = type === 'switch' || type === 'switches' ? _core.Switch : _core.Checkbox;

    var addUnique = function addUnique(list, item) {
        return list.indexOf(item) >= 0 ? list : [].concat((0, _toConsumableArray3.default)(list), [item]);
    };

    var changeHandler = function changeHandler(e, checked) {
        return onChange(name, multiple ? checked ? addUnique(value, option) : value.filter(function (v) {
            return v !== option;
        }) : checked ? option : option === true ? false : '', // if boolean value, return the opposite, otherwise empty string for non-checked
        value);
    };

    if (multiple) (0, _assert2.default)(value instanceof Array, "Expected value to be array");

    var input = _react2.default.createElement(SwitchOrCheckbox, (0, _extends3.default)({
        checked: multiple ? value && value.indexOf(option) >= 0 : value === option,
        color: color,
        disabled: disabled,
        id: id || 'i_' + name,
        inputProps: nativeInputProps,
        name: name,
        onChange: changeHandler
    }, inputProps));

    return !wrapped ? input : _react2.default.createElement(_core.FormControlLabel, {
        control: input,
        margin: margin,
        label: label + (required ? '*' : '')
    });
};

CheckboxOrSwitch.propTypes = {
    color: _propTypes2.default.oneOf(['primary', 'secondary', 'default']),
    disabled: _propTypes2.default.bool,
    id: _propTypes2.default.string,
    inputProps: _propTypes2.default.object,
    label: _propTypes2.default.string.isRequired,
    margin: _propTypes2.default.oneOf(['none', 'dense', 'normal']),
    multiple: _propTypes2.default.bool,
    name: _propTypes2.default.string.isRequired,
    nativeInputProps: _propTypes2.default.object,
    onChange: _propTypes2.default.func.isRequired,
    option: _propTypes2.default.any,
    required: _propTypes2.default.bool,
    type: _propTypes2.default.oneOf(['checkbox', 'checkboxes', 'switch', 'switches']),
    value: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])), _propTypes2.default.string, _propTypes2.default.number]).isRequired,
    wrapped: _propTypes2.default.bool
};

CheckboxOrSwitch.defaultProps = {
    multiple: false,
    option: true,
    type: 'checkbox',
    wrapped: true
};

exports.default = CheckboxOrSwitch;