'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FormControl = require('../FormControl/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _core = require('@material-ui/core');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var style = {
    iconOpen: {
        transform: "scale(0)"
    },
    icon: {
        transition: "all .5s"
    },
    searchContainer: {
        width: "0",
        transition: '.5s all',
        overflow: 'hidden',
        display: 'inline-block'
    },
    searchContainerOpen: {
        width: "200px"
    }
};

var FoldSearch = function (_PureComponent) {
    (0, _inherits3.default)(FoldSearch, _PureComponent);

    function FoldSearch() {
        (0, _classCallCheck3.default)(this, FoldSearch);

        var _this = (0, _possibleConstructorReturn3.default)(this, (FoldSearch.__proto__ || (0, _getPrototypeOf2.default)(FoldSearch)).call(this));

        _this.state = {
            open: false
        };

        _this.toggleOpen = _this.toggleOpen.bind(_this);
        _this.textInput = _react2.default.createRef();
        return _this;
    }

    (0, _createClass3.default)(FoldSearch, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            if (props.searchQuery.length > 0 && !this.state.open) {
                this.setState({
                    open: true
                });
            }
        }
    }, {
        key: 'toggleOpen',
        value: function toggleOpen() {
            var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

            if (!this.state.open && v !== false) {
                this.textInput.current.focus();
            }

            this.setState(function (s) {
                return {
                    open: v === null ? !s.open : v
                };
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                searchQuery = _props.searchQuery,
                label = _props.label,
                onChange = _props.onChange,
                searchHint = _props.searchHint,
                classes = _props.classes;
            var open = this.state.open;

            return _react2.default.createElement(
                'div',
                { style: { maxWidth: "332px", height: 48, display: 'flex', alignItems: 'center', float: 'right' } },
                _react2.default.createElement(
                    'div',
                    { className: (0, _classnames2.default)(classes.searchContainer, (0, _defineProperty3.default)({}, classes.searchContainerOpen, open)) },
                    _react2.default.createElement(_FormControl2.default, {
                        value: searchQuery,
                        label: '',
                        name: 'search',
                        fullWidth: true,
                        clearable: false,
                        placeholder: label,
                        autoFocus: true,
                        inputProps: {
                            disableUnderline: true,
                            inputRef: this.textInput,
                            onBlur: function onBlur() {
                                return searchQuery.length == 0 && _this2.toggleOpen(false);
                            }
                        },
                        onChange: onChange

                    })
                ),
                _react2.default.createElement(
                    _core.Tooltip,
                    { title: searchHint },
                    _react2.default.createElement(
                        _core.IconButton,
                        { onClick: this.toggleOpen, className: (0, _classnames2.default)(classes.icon, (0, _defineProperty3.default)({}, classes.iconOpen, open)) },
                        _react2.default.createElement(
                            _core.Icon,
                            null,
                            'search'
                        )
                    )
                )
            );
        }
    }]);
    return FoldSearch;
}(_react.PureComponent);

exports.default = (0, _styles.withStyles)(style)(FoldSearch);