'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CheckboxOrSwitch = require('../CheckboxOrSwitch/CheckboxOrSwitch');

var _CheckboxOrSwitch2 = _interopRequireDefault(_CheckboxOrSwitch);

var _MultiSelection = require('../MultiSelection/MultiSelection');

var _MultiSelection2 = _interopRequireDefault(_MultiSelection);

var _Radio = require('../Radio/Radio');

var _Radio2 = _interopRequireDefault(_Radio);

var _Select = require('../Select/Select');

var _Select2 = _interopRequireDefault(_Select);

var _TextField = require('../TextField/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * FormControl allows a uniform approach to all types of form-controls
 * and is fully parameterizable. Hence the appearance of any field can
 * be fully specified by its properties.
 * @param {*} props 
 */
var FormControl = function (_PureComponent) {
    (0, _inherits3.default)(FormControl, _PureComponent);

    function FormControl() {
        (0, _classCallCheck3.default)(this, FormControl);
        return (0, _possibleConstructorReturn3.default)(this, (FormControl.__proto__ || (0, _getPrototypeOf2.default)(FormControl)).apply(this, arguments));
    }

    (0, _createClass3.default)(FormControl, [{
        key: 'render',
        value: function render() {
            var props = this.props;

            var _props = (0, _extends3.default)({}, props),
                inputProps = (0, _objectWithoutProperties3.default)(_props, []);

            inputProps.type = props.type || 'text';

            switch (props.type) {
                case 'radio':
                    return _react2.default.createElement(_Radio2.default, inputProps);
                case 'radios':
                    return _react2.default.createElement(_MultiSelection2.default, (0, _extends3.default)({ Control: _Radio2.default }, inputProps));
                case 'checkbox':
                    return _react2.default.createElement(_CheckboxOrSwitch2.default, inputProps);
                case 'checkboxes':
                    return _react2.default.createElement(_MultiSelection2.default, (0, _extends3.default)({ Control: _CheckboxOrSwitch2.default }, inputProps));
                case 'switch':
                    return _react2.default.createElement(_CheckboxOrSwitch2.default, inputProps);
                case 'switches':
                    return _react2.default.createElement(_MultiSelection2.default, (0, _extends3.default)({ Control: _CheckboxOrSwitch2.default }, inputProps));
                case 'select':
                case 'selectmany':
                    return _react2.default.createElement(_Select2.default, (0, _extends3.default)({ multiple: props.type === 'selectmany' }, inputProps));
                case 'date':
                case 'datetime-local':
                case 'email':
                case 'month':
                case 'number':
                case 'integer':
                case 'password':
                case 'search':
                case 'text':
                case 'time':
                case 'week':
                case 'textarea':
                case undefined:
                    // Default
                    return _react2.default.createElement(_TextField2.default, inputProps);
                default:
                    throw new Error('Unknown input type \'' + props.type + '\'');
            }
        }
    }]);
    return FormControl;
}(_react.PureComponent);

exports.default = FormControl;