'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _core = require('@material-ui/core');

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var helper = function helper(msg) {
    var isError = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    return _react2.default.createElement(
        _core.FormHelperText,
        { error: isError },
        msg
    );
};

var style = {};

var FormControlWrap = function FormControlWrap(_ref) {
    var children = _ref.children,
        classes = _ref.classes,
        disabled = _ref.disabled,
        errors = _ref.errors,
        formControlProps = _ref.formControlProps,
        fullWidth = _ref.fullWidth,
        helperText = _ref.helperText,
        id = _ref.id,
        inputLabelProps = _ref.inputLabelProps,
        label = _ref.label,
        labelUp = _ref.labelUp,
        largeLabel = _ref.largeLabel,
        margin = _ref.margin,
        name = _ref.name,
        required = _ref.required,
        showErrors = _ref.showErrors,
        startAdornment = _ref.startAdornment,
        value = _ref.value,
        withinTable = _ref.withinTable;


    var idx = id || 'i_' + name;

    var empty = value === '' || value instanceof Array && value.length == 0;
    var labelType = !label || withinTable && !empty ? 'none' : largeLabel ? 'form' : 'input';
    var labelShrink = withinTable === true ? false : labelUp || startAdornment;

    return _react2.default.createElement(
        _core.FormControl,
        (0, _extends3.default)({
            disabled: disabled,
            error: showErrors,
            fullWidth: fullWidth,
            id: idx + '_control',
            margin: margin,
            required: required
        }, formControlProps),
        labelType === 'form' && _react2.default.createElement(
            _core.FormLabel,
            inputLabelProps,
            label
        ),
        labelType === 'input' && _react2.default.createElement(
            _core.InputLabel,
            (0, _extends3.default)({ htmlFor: idx, shrink: labelShrink }, inputLabelProps),
            label
        ),
        children,
        showErrors && errors.length > 0 ? helper(errors[0], true) : helperText ? helper(helperText) : ''
    );
};

FormControlWrap.propTypes = {
    disabled: _propTypes2.default.bool,
    errors: _propTypes2.default.arrayOf(_propTypes2.default.string),
    formControlProps: _propTypes2.default.object,
    fullWidth: _propTypes2.default.bool,
    helperText: _propTypes2.default.string,
    id: _propTypes2.default.string,
    inputLabelProps: _propTypes2.default.object,
    label: _propTypes2.default.string,
    labelUp: _propTypes2.default.bool,
    largeLabel: _propTypes2.default.bool,
    margin: _propTypes2.default.oneOf(['dense', 'none']),
    name: _propTypes2.default.string.isRequired,
    required: _propTypes2.default.bool,
    showErrors: _propTypes2.default.bool,
    startAdornment: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.string]),
    withinTable: _propTypes2.default.bool
};

FormControlWrap.defaultProps = {
    largeLabel: false,
    withinTable: false
};

exports.default = (0, _styles.withStyles)(style)(FormControlWrap);