'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _validatorjs = require('validatorjs');

var _validatorjs2 = _interopRequireDefault(_validatorjs);

var _objectAppend = require('../utilities/object-append');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var basicValidator = function basicValidator(data, rules) {
    return new _validatorjs2.default(data, rules instanceof Function ? rules(data) : rules).errors.all();
};

var FormLogic = function (_PureComponent) {
    (0, _inherits3.default)(FormLogic, _PureComponent);

    function FormLogic(props) {
        (0, _classCallCheck3.default)(this, FormLogic);

        var _this = (0, _possibleConstructorReturn3.default)(this, (FormLogic.__proto__ || (0, _getPrototypeOf2.default)(FormLogic)).call(this));

        _this.state = {
            data: {},
            errors: {},
            hasErrors: false
        };


        _this.handleChange = _this.handleChange.bind(_this);
        _this.handleClear = _this.handleClear.bind(_this);
        _this.handleSubmit = _this.handleSubmit.bind(_this);
        _this.handleCancel = _this.handleCancel.bind(_this);

        _this.state.data = props.data;
        return _this;
    }

    (0, _createClass3.default)(FormLogic, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var errors = this.props.validate(this.state.data, this.props.rules);
            this.setState({
                errors: errors,
                hasErrors: !_lodash2.default.isEmpty(errors)
            });
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            // Replace the data if the parent provides new data
            if (newProps.data !== this.state.data) {
                this.setState({
                    data: newProps.data
                });
            }
        }
    }, {
        key: 'handleChange',
        value: function handleChange(fieldName, newValue) {
            this.setState(function (state, props) {
                var validate = props.validate,
                    rules = props.rules;

                var data = (0, _objectAppend.replaceDeep)(state.data, fieldName, newValue);
                var errors = validate(data, rules);

                return { data: data, errors: errors, hasErrors: !_lodash2.default.isEmpty(errors) };
            });
        }
    }, {
        key: 'handleSubmit',
        value: function handleSubmit() {
            if (!this.state.hasErrors) {
                this.props.onSubmit(this.state.data);
            }
        }
    }, {
        key: 'handleClear',
        value: function handleClear() {
            this.setState({
                data: this.props.defaults
            });
        }
    }, {
        key: 'handleCancel',
        value: function handleCancel() {}
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                Form = _props.Form,
                formProps = _props.formProps;
            var _state = this.state,
                data = _state.data,
                errors = _state.errors;


            var form = {
                data: data,
                errors: errors,
                onChange: this.handleChange,
                onSubmit: this.handleSubmit,
                onClear: this.handleClear
            };

            return _react2.default.createElement(Form, (0, _extends3.default)({ form: form }, formProps));
        }
    }]);
    return FormLogic;
}(_react.PureComponent);

FormLogic.propTypes = {
    /**
     * Form data
     */
    data: _propTypes2.default.object.isRequired,

    /**
     * Values to which form will be restored on 'clear'
     * and compared for dirty inputs.
     */
    defaults: _propTypes2.default.object.isRequired,

    /**
     * Validation function 
     * (data, rules) => { [fieldName]: errors[] }
     */
    validate: _propTypes2.default.func,

    /**
     * Validation rules for each field
     * { [fieldName]: rules }
     */
    rules: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func]),

    /**
     * Function to lock navigation upon 
     */
    lockNavigation: _propTypes2.default.func,

    /**
     * Callback for submitted data, will only be called
     * when data validates.
     */
    onSubmit: _propTypes2.default.func.isRequired
};

FormLogic.defaultProps = {
    validate: basicValidator
};

exports.default = FormLogic;

// props: data, onSubmit, onCancel, lockPage