'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CompanyLogo = require('../CompanyLogo/CompanyLogo');

var _CompanyLogo2 = _interopRequireDefault(_CompanyLogo);

var _styles = require('@material-ui/core/styles');

var _core = require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
    root: {
        display: 'flex',
        flexDirection: 'column',
        width: '100%',
        minHeight: '100vh',
        alignItems: 'center',
        justifyContent: 'center',
        backgroundColor: '#ddd',
        padding: '24px 0',
        boxSizing: 'border-box'
    },

    logo: {
        maxWidth: '90%',
        marginBottom: 48
    },

    paper: {
        width: 400
    },

    body: {
        padding: 24
    },

    footer: {
        padding: '12px 24px',
        display: 'flex',
        justifyContent: 'space-between'
    },

    token: {
        width: '100%',
        wordWrap: 'break-word',
        color: '#aaa'
    }
};

var LoginGuardPage = function (_Component) {
    (0, _inherits3.default)(LoginGuardPage, _Component);

    function LoginGuardPage() {
        (0, _classCallCheck3.default)(this, LoginGuardPage);
        return (0, _possibleConstructorReturn3.default)(this, (LoginGuardPage.__proto__ || (0, _getPrototypeOf2.default)(LoginGuardPage)).apply(this, arguments));
    }

    (0, _createClass3.default)(LoginGuardPage, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                classes = _props.classes,
                auth = _props.auth;


            return _react2.default.createElement(
                'div',
                { className: classes.root },
                _react2.default.createElement(_CompanyLogo2.default, { withText: true, className: classes.logo }),
                _react2.default.createElement(
                    _core.Paper,
                    { className: classes.paper },
                    auth.loggedOut && _react2.default.createElement(
                        'div',
                        { className: classes.body },
                        _react2.default.createElement(
                            'h3',
                            null,
                            'Doorverwijzen...'
                        ),
                        _react2.default.createElement(
                            'p',
                            null,
                            'U wordt doorverwezen naar de inlogpagina. Zo niet, klik hier:'
                        ),
                        _react2.default.createElement(
                            _core.Button,
                            { onClick: function onClick() {
                                    return window.location = _this2.props.redirectTo;
                                } },
                            'Naar Inlogpagina'
                        )
                    ),
                    auth.verifying && _react2.default.createElement(
                        'div',
                        { className: classes.body },
                        _react2.default.createElement(
                            'h3',
                            null,
                            'Inloggen..'
                        ),
                        _react2.default.createElement(
                            'p',
                            null,
                            'Uw gegevens worden opgehaald. Als dit te lang duurt, neem contact op met de service desk.'
                        ),
                        _react2.default.createElement(
                            'small',
                            { className: classes.token },
                            auth.token
                        )
                    ),
                    auth.failure && _react2.default.createElement(
                        'div',
                        { className: classes.body },
                        _react2.default.createElement(
                            'h3',
                            null,
                            'Foutmelding'
                        ),
                        _react2.default.createElement(
                            'p',
                            null,
                            'Er ging iets fout, neem contact op met de service desk.'
                        ),
                        _react2.default.createElement(
                            'strong',
                            null,
                            'Foutmelding: ',
                            auth.error
                        )
                    )
                )
            );
        }
    }]);
    return LoginGuardPage;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(LoginGuardPage);