'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _jsonwebtoken = require('jsonwebtoken');

var _jsonwebtoken2 = _interopRequireDefault(_jsonwebtoken);

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tokenIsExpired = function tokenIsExpired(token, secondsBefore) {
    var d = _jsonwebtoken2.default.decode(token);
    return !d || d.exp <= Math.floor(new Date().getTime() / 1000) - secondsBefore;
};

var LoginLogic = function (_PureComponent) {
    (0, _inherits3.default)(LoginLogic, _PureComponent);

    function LoginLogic() {
        var _ref,
            _this2 = this;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, LoginLogic);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = LoginLogic.__proto__ || (0, _getPrototypeOf2.default)(LoginLogic)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            token: null,
            refreshToken: null,
            currentUser: null,
            error: null,
            status: 'loggedOut' // loggedIn, loggingIn, failure


            /** Verify whether login is (still valid), otherwise take action */
        }, _this.verify = function () {
            if (_this.state.status === 'loggedIn') {
                return _this.refreshTokenIfNecessary();
            } else {
                var token = _this.discoverToken();

                if (token) _this.onNewToken(token);else _this.props.onRequireLogin();
            }
        }, _this.onNewToken = function (token) {
            _this.saveTokenInCookie(token);
            _this._setState({ token: token }).then(function () {
                if (!_this.state.currentUser) _this.fetchMe();

                if (_this.props.onReceiveToken) _this.props.onReceiveToken(token);
            });
        }, _this.fetchMe = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
            var user;
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.prev = 0;

                            if (!(_this.state.status === 'verifying')) {
                                _context.next = 3;
                                break;
                            }

                            return _context.abrupt('return');

                        case 3:
                            _context.next = 5;
                            return _this._setState({ status: 'verifying' });

                        case 5:
                            _context.next = 7;
                            return _this.props.fetchMe(_this.state.token);

                        case 7:
                            user = _context.sent;
                            _context.next = 10;
                            return _this._setState({
                                currentUser: user,
                                status: 'loggedIn'
                            });

                        case 10:

                            if (!_this.state.refreshToken) _this.props.fetchRefreshToken(_this.state.token, user.id).then(function (refreshToken) {
                                return _this._setState({ refreshToken: refreshToken });
                            });

                            return _context.abrupt('return', _this.state.currentUser);

                        case 14:
                            _context.prev = 14;
                            _context.t0 = _context['catch'](0);

                            _this.setState({
                                status: 'failure',
                                token: null,
                                error: _context.t0
                            });

                        case 17:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, _this2, [[0, 14]]);
        })), _this.discoverToken = function () {
            var tokenUrl = _this.getTokenFromURL();
            if (tokenUrl && !tokenIsExpired(tokenUrl, _this.props.refreshBefore)) return tokenUrl;

            var tokenCookie = _this.getTokenFromCookie();
            if (tokenCookie && !tokenIsExpired(tokenCookie, _this.props.refreshBefore)) return tokenCookie;
        }, _this.refreshTokenIfNecessary = function () {
            var _this$state = _this.state,
                token = _this$state.token,
                currentUser = _this$state.currentUser,
                refreshToken = _this$state.refreshToken;


            if (token && tokenIsExpired(token, _this.props.refreshBefore)) _this.props.fetchNewToken(currentUser.id, refreshToken).then(_this.onNewToken);
        }, _this.getTokenFromURL = function () {
            var match = _this.props.getLocationHash().match(/token=([a-zA-Z\.0-9\-_]*)/);
            return match ? match[1] : null;
        }, _this.getTokenFromCookie = function () {
            return _this.props.getCookie(_this.props.cookieKey);
        }, _this.saveTokenInCookie = function (token) {
            _this.props.setCookie(_this.props.cookieKey, token);
        }, _this.handleLogout = function () {
            _this.props.removeCookie(_this.props.cookieKey);
            _this._setState({
                token: null,
                refreshToken: null,
                currentUser: null,
                error: null,
                status: 'loggedOut'
            }).then(_this.props.onLogout);
        }, _this.makeAuth = function () {
            var _this$state2 = _this.state,
                token = _this$state2.token,
                currentUser = _this$state2.currentUser,
                status = _this$state2.status,
                error = _this$state2.error;

            return {
                logout: _this.handleLogout,
                token: token,
                currentUser: currentUser,
                status: status,
                error: error,
                loggedIn: status === 'loggedIn',
                loggedOut: status === 'loggedOut',
                verifying: status === 'verifying',
                failure: status === 'failure'
            };
        }, _this._setState = function (s) {
            return new _promise2.default(function (resolve) {
                return _this.setState(s, resolve);
            });
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    /** Fetch the user associated with the current token */


    /** Discover an unexpired token from a URL or cookie */


    /** Check whether the token is still fresh, otherwise fetch a new one */


    (0, _createClass3.default)(LoginLogic, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.verify();

            setInterval(this.verify, this.props.verifyInterval);
        }
    }, {
        key: 'render',
        value: function render() {
            var children = this.props.children;

            var auth = this.makeAuth();
            return children({ auth: auth });
        }
    }]);
    return LoginLogic;
}(_react.PureComponent);

LoginLogic.propTypes = {

    /**
     * The function to redirect the user when not logged in
     */
    onRequireLogin: _propTypes2.default.func.isRequired,

    /**
     * Callback for when (new) auth token is received
     */
    onReceiveToken: _propTypes2.default.func,

    /**
     * The function that fetches the current user
     * Takes a token and returns a Promise to the user object
     */
    fetchMe: _propTypes2.default.func.isRequired,

    /**
     * The function that fetches the refresh token
     * (authToken, userId) => Promise(newToken)
     */
    fetchRefreshToken: _propTypes2.default.func.isRequired,

    /**
     * The function to redirect the user after logging out
     */
    onLogout: _propTypes2.default.func,

    children: _propTypes2.default.func.isRequired,

    getLocationHash: _propTypes2.default.func.isRequired,
    getCookie: _propTypes2.default.func.isRequired,
    setCookie: _propTypes2.default.func.isRequired,
    removeCookie: _propTypes2.default.func.isRequired,

    /** The period in seconds after which the token expiry is verified */
    verifyInterval: _propTypes2.default.number,

    /** The number of seconds to refresh the token before actual expiry */
    refreshBefore: _propTypes2.default.number,

    /** The key of the cookie under which the auth token is */
    cookieKey: _propTypes2.default.string
};

LoginLogic.defaultProps = {
    getLocationHash: function getLocationHash() {
        return window.location.hash || "";
    },
    getCookie: _jsCookie2.default.get,
    setCookie: _jsCookie2.default.set,
    removeCookie: _jsCookie2.default.remove,

    verifyInterval: 2,
    refreshBefore: 120,
    cookieKey: 'huiskamp_tkn'
};

exports.default = LoginLogic;