'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FormControl = require('../FormControl/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _CompanyLogo = require('../CompanyLogo/CompanyLogo');

var _CompanyLogo2 = _interopRequireDefault(_CompanyLogo);

var _ProgressButton = require('../ProgressButton/ProgressButton');

var _ProgressButton2 = _interopRequireDefault(_ProgressButton);

var _styles = require('@material-ui/core/styles');

var _core = require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
    root: {
        display: 'flex',
        flexDirection: 'column',
        width: '100%',
        height: '100%',
        alignItems: 'center',
        justifyContent: 'center',
        backgroundColor: '#ddd'
    },

    logo: {
        maxWidth: '90%',
        marginBottom: 48
    },

    paper: {
        width: 400
    },

    body: {
        padding: 24
    },

    footer: {
        padding: '12px 24px',
        display: 'flex',
        justifyContent: 'space-between'
    }
};

var LoginPage = function (_Component) {
    (0, _inherits3.default)(LoginPage, _Component);

    function LoginPage() {
        (0, _classCallCheck3.default)(this, LoginPage);

        var _this = (0, _possibleConstructorReturn3.default)(this, (LoginPage.__proto__ || (0, _getPrototypeOf2.default)(LoginPage)).call(this));

        _this.state = {
            username: '',
            password: '',
            error: '',
            pending: false
        };


        _this.handleSubmit = _this.handleSubmit.bind(_this);
        _this.handleChange = _this.handleChange.bind(_this);
        return _this;
    }

    (0, _createClass3.default)(LoginPage, [{
        key: 'setPending',
        value: function setPending() {
            var to = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

            return this._setState({
                pending: to
            });
        }
    }, {
        key: '_setState',
        value: function _setState(setter) {
            var self = this;
            return new _promise2.default(function (resolve) {
                self.setState(setter, function () {
                    return resolve();
                });
            });
        }
    }, {
        key: 'handleSubmit',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(e) {
                var _state, username, password;

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                if (e) e.preventDefault();
                                _state = this.state, username = _state.username, password = _state.password;
                                _context.next = 4;
                                return this.setPending();

                            case 4:

                                this.props.login({ username: username, password: password }).catch(this.handleLoginError.bind(this));

                            case 5:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function handleSubmit(_x2) {
                return _ref.apply(this, arguments);
            }

            return handleSubmit;
        }()
    }, {
        key: 'handleLoginError',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(error) {
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                this.setState({
                                    pending: false,
                                    error: error
                                });

                            case 1:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function handleLoginError(_x3) {
                return _ref2.apply(this, arguments);
            }

            return handleLoginError;
        }()
    }, {
        key: 'handleChange',
        value: function handleChange(f, v) {
            this.setState((0, _defineProperty3.default)({}, f, v));
        }
    }, {
        key: 'render',
        value: function render() {
            var classes = this.props.classes;
            var _state2 = this.state,
                pending = _state2.pending,
                error = _state2.error;


            return _react2.default.createElement(
                'div',
                { className: classes.root },
                _react2.default.createElement(_CompanyLogo2.default, { withText: true, className: classes.logo }),
                _react2.default.createElement(
                    _core.Paper,
                    { className: classes.paper },
                    _react2.default.createElement(
                        'form',
                        { onSubmit: this.handleSubmit },
                        _react2.default.createElement(
                            'div',
                            { className: classes.body },
                            _react2.default.createElement(
                                'h3',
                                null,
                                'Inloggen voor medewerkers'
                            ),
                            _react2.default.createElement(_FormControl2.default, {
                                name: 'username',
                                onChange: this.handleChange,
                                label: 'Gebruikersnaam',
                                showErrors: !!error,
                                errors: [],
                                startAdornment: _react2.default.createElement(
                                    _core.Icon,
                                    null,
                                    'person'
                                ),
                                margin: 'normal'
                            }),
                            _react2.default.createElement(_FormControl2.default, {
                                name: 'password',
                                margin: 'normal',
                                onChange: this.handleChange,
                                label: 'Wachtwoord',
                                errors: error ? [error] : [],
                                showErrors: !!error,
                                startAdornment: _react2.default.createElement(
                                    _core.Icon,
                                    null,
                                    'lock'
                                ),
                                type: 'password'
                            })
                        ),
                        _react2.default.createElement(_core.Divider, null),
                        _react2.default.createElement(
                            'div',
                            { className: classes.footer },
                            _react2.default.createElement(
                                _core.Button,
                                {
                                    type: 'submit',
                                    disabled: true
                                },
                                'Wachtwoord vergeten'
                            ),
                            _react2.default.createElement(
                                _ProgressButton2.default,
                                {
                                    type: 'submit',
                                    color: 'primary',
                                    pending: pending
                                },
                                'Inloggen'
                            )
                        )
                    )
                )
            );
        }
    }]);
    return LoginPage;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(LoginPage);