"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _core = require("@material-ui/core");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _optionSpec = require("../utilities/option-spec");

var _FormControlWrap = require("../FormControlWrap/FormControlWrap");

var _FormControlWrap2 = _interopRequireDefault(_FormControlWrap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MultiSelection = function MultiSelection(props) {
    var Control = props.Control,
        name = props.name,
        label = props.label,
        largeLabel = props.largeLabel,
        options = props.options,
        orientation = props.orientation,
        wrapped = props.wrapped;


    var groupProps = largeLabel ? {} : { style: { marginTop: 8 } };

    var input = _react2.default.createElement(
        _core.FormGroup,
        (0, _extends3.default)({ row: orientation === 'horizontal' }, groupProps),
        (0, _optionSpec.flattenOptionSpec)((0, _optionSpec.optionSpecToArray)(options)).map(function (option) {
            return option.isHeader ? _react2.default.createElement(
                "div",
                null,
                option.label
            ) : _react2.default.createElement(Control, (0, _extends3.default)({ key: option.value }, props, { option: option.value, label: option.label }));
        })
    );

    return !wrapped ? input : _react2.default.createElement(
        _FormControlWrap2.default,
        (0, _extends3.default)({ largeLabel: largeLabel, labelUp: true }, props),
        input
    );
};

MultiSelection.propTypes = {
    Control: _propTypes2.default.func,
    name: _propTypes2.default.string.isRequired,
    label: _propTypes2.default.string,
    largeLabel: _propTypes2.default.bool,
    options: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]), //P.oneOfType([pOptDict, pOptList]),
    orientation: _propTypes2.default.oneOf(['horizontal', 'vertical']),
    wrapped: _propTypes2.default.bool
};

MultiSelection.defaultProps = {
    largeLabel: true,
    wrapped: true
};

exports.default = MultiSelection;