'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NavigationLogic = function (_PureComponent) {
    (0, _inherits3.default)(NavigationLogic, _PureComponent);

    function NavigationLogic() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, NavigationLogic);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = NavigationLogic.__proto__ || (0, _getPrototypeOf2.default)(NavigationLogic)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            page: '',
            PageComponent: null,
            params: {},
            locked: false
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(NavigationLogic, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            window.addEventListener('hashchange', this.handleHashChange.bind(this));
            this.handleHashChange();
        }
    }, {
        key: 'handlePageChange',
        value: function handlePageChange(pageName) {
            this.setState({
                page: pageName
            });
        }
    }, {
        key: 'handleHashChange',
        value: function handleHashChange() {
            var hash = window.location.hash;

            var _state = this.state,
                page = _state.page,
                params = _state.params,
                locked = _state.locked;
            var _props = this.props,
                router = _props.router,
                onNavigate = _props.onNavigate;

            var _hash$substr$split = hash.substr(1).split('?', 2),
                _hash$substr$split2 = (0, _slicedToArray3.default)(_hash$substr$split, 2),
                newPage = _hash$substr$split2[0],
                newQuery = _hash$substr$split2[1];

            var newParams = _queryString2.default.parse(newQuery);

            // Check the block
            if (locked) {
                var confirmation = this.askUserConfirmation();
                if (!confirmation) return this.setLocation(page, params);
            }

            // Check the page exists
            var action = router(newPage, newParams);

            // assert(action && action.type, "Expected router to return a proper action object")

            if (action.type === 'redirect') return this.setLocation(action.page, action.params || {});

            if (action.type === 'result') {
                // Navigate
                this.setState({
                    page: newPage,
                    params: newParams,
                    PageComponent: action.PageComponent,
                    locked: false
                }, function () {
                    if (onNavigate) onNavigate(newPage, newParams);
                });
            }
        }
    }, {
        key: 'setLocation',
        value: function setLocation(page, params) {
            window.location.hash = '' + page + (params ? '?' + _queryString2.default.stringify(params) : '');
        }
    }, {
        key: 'setUrlParam',
        value: function setUrlParam(param, value) {
            this.setUrlParams((0, _extends4.default)({}, this.state.params, (0, _defineProperty3.default)({}, param, value)));
        }
    }, {
        key: 'setUrlParams',
        value: function setUrlParams(newParams) {
            this.setLocation(this.state.page, newParams);
        }
    }, {
        key: 'askUserConfirmation',
        value: function askUserConfirmation() {
            // ask user if she is certain
            return window.confirm(this.props.confirmMessage);
        }
    }, {
        key: 'toggleNavLock',
        value: function toggleNavLock(lockOn) {
            var _this2 = this;

            if (lockOn) {
                window.onbeforeunload = function () {
                    return _this2.props.confirmMessage;
                };
            } else {
                window.onbeforeunload = null;
            }
            console.log("Toggle nav lock to", lockOn);

            this.setState({
                locked: lockOn
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _state2 = this.state,
                page = _state2.page,
                params = _state2.params,
                locked = _state2.locked,
                PageComponent = _state2.PageComponent;
            var pageProps = this.props.pageProps;


            var navigation = {
                page: page,
                params: params,
                locked: locked,
                lock: this.toggleNavLock.bind(this),
                setParams: this.setUrlParams.bind(this),
                setParam: this.setUrlParam.bind(this)
            };

            return PageComponent ? _react2.default.createElement(PageComponent, (0, _extends4.default)({ navigation: navigation }, pageProps)) : 'No page component present..';
        }
    }]);
    return NavigationLogic;
}(_react.PureComponent);

NavigationLogic.propTypes = {
    router: _propTypes2.default.func.isRequired,
    onNavigate: _propTypes2.default.func,
    confirmMessage: _propTypes2.default.string,
    pageProps: _propTypes2.default.object
};

NavigationLogic.defaultProps = {
    confirmMessage: 'U heeft onopgeslagen wijzigingen. Weet u zeker dat u deze pagina wilt verlaten?'
};

exports.default = NavigationLogic;