"use strict";

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _ProgressButton = require("./ProgressButton");

var _ProgressButton2 = _interopRequireDefault(_ProgressButton);

var _chai = require("chai");

var _sinon = require("sinon");

var _sinon2 = _interopRequireDefault(_sinon);

var _enzymeSetup = require("../utilities/enzyme-setup");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe("ProgressButton", function () {
    it("renders the content", function () {
        var wrapper = (0, _enzymeSetup.shallow)(_react2.default.createElement(
            _ProgressButton2.default,
            null,
            "The Content"
        ));
        (0, _chai.expect)(wrapper.contains("The Content")).to.equal(true);
    });
    it("handles a click", function () {
        var onClick = _sinon2.default.spy();
        var wrapper = (0, _enzymeSetup.shallow)(_react2.default.createElement(
            _ProgressButton2.default,
            { onClick: onClick },
            "The Content"
        ));
        wrapper.simulate('click');
        (0, _chai.expect)(onClick).to.have.property('callCount', 1);
    });
});