'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _core = require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Radio = function Radio(_ref) {
    var color = _ref.color,
        disabled = _ref.disabled,
        id = _ref.id,
        inputProps = _ref.inputProps,
        label = _ref.label,
        name = _ref.name,
        nativeInputProps = _ref.nativeInputProps,
        _onChange = _ref.onChange,
        option = _ref.option,
        required = _ref.required,
        value = _ref.value;
    return _react2.default.createElement(_core.FormControlLabel, {
        control: _react2.default.createElement(_core.Radio, (0, _extends3.default)({
            checked: value === option,
            color: color,
            disabled: disabled,
            id: id || 'i_' + name + '_' + option,
            inputProps: nativeInputProps,
            name: name,
            onChange: function onChange() {
                return _onChange(name, option, value);
            },
            value: option
        }, inputProps)),
        label: label + (required ? '*' : '')
    });
};

Radio.propTypes = {
    color: _propTypes2.default.oneOf(['primary', 'secondary', 'default']),
    disabled: _propTypes2.default.bool,
    id: _propTypes2.default.string,
    inputProps: _propTypes2.default.object,
    label: _propTypes2.default.string.isRequired,
    name: _propTypes2.default.string.isRequired,
    nativeInputProps: _propTypes2.default.object,
    onChange: _propTypes2.default.func.isRequired,
    option: _propTypes2.default.any,
    required: _propTypes2.default.bool,
    value: _propTypes2.default.any.isRequired
};

exports.default = Radio;