'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _core = require('@material-ui/core');

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var computePipe = function computePipe(funcOrFuncs) {
    for (var _len = arguments.length, inputParams = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        inputParams[_key - 1] = arguments[_key];
    }

    var funcs = funcOrFuncs instanceof Array ? funcOrFuncs : [funcOrFuncs]; // standardize to array
    return funcs.reduce(function (result, func) {
        return [func.apply(undefined, (0, _toConsumableArray3.default)(result))].concat(inputParams);
    }, [].concat(inputParams))[0];
};

var is = function is(x) {
    for (var _len2 = arguments.length, types = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        types[_key2 - 1] = arguments[_key2];
    }

    return types.reduce(function (match, type) {
        return match || (typeof x === 'undefined' ? 'undefined' : (0, _typeof3.default)(x)) === type;
    }, false);
};

var style = {
    'cell-numeric': {
        textAlign: 'right',

        "& input": {
            textAlign: 'right'
        }
    },
    'cell-button': {
        padding: 0,
        textAlign: 'center'
    },
    'cell-input': {
        // background: '#f5f5f5',
        paddingLeft: 16,
        paddingRight: 16
    }
    // 'cell-calculated': {
    // background: '#f5f5f5'
    // }
};

var toArray = function toArray(x) {
    return x instanceof Array ? x : x === undefined ? [] : [x];
};

var RecordRow = function (_PureComponent) {
    (0, _inherits3.default)(RecordRow, _PureComponent);

    function RecordRow() {
        (0, _classCallCheck3.default)(this, RecordRow);
        return (0, _possibleConstructorReturn3.default)(this, (RecordRow.__proto__ || (0, _getPrototypeOf2.default)(RecordRow)).apply(this, arguments));
    }

    (0, _createClass3.default)(RecordRow, [{
        key: 'render',


        /** Render the Row */
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                row = _props.row,
                columns = _props.columns,
                index = _props.index,
                hover = _props.hover;


            return _react2.default.createElement(
                _core.TableRow,
                { hover: hover, classes: {} },
                columns.map(function (column) {
                    return _this2.renderTableCell(row, column, index);
                })
            );
        }

        /** Render a cell */

    }, {
        key: 'renderTableCell',
        value: function renderTableCell(row, column, rowIndex) {
            var classes = this.props.classes;

            var contents = computePipe(column.format, row, rowIndex);
            var className = !column.className ? null : is(column.className, 'string') ? column.className : computePipe(column.className, row);
            var cellProps = !column.cellProps ? {} : is(column.cellProps, 'array', 'function') ? computePipe(column.cellProps, row) : column.cellProps;
            var variant = !column.variant ? '' : is(column.variant, 'function') ? computePipe(column.variant, row) : column.variant;

            return _react2.default.createElement(
                _core.TableCell,
                (0, _extends3.default)({
                    className: className + ' ' + toArray(variant).map(function (variant) {
                        return classes['cell-' + variant];
                    }).join(' '),
                    key: column.id
                }, cellProps),
                contents
            );
        }
    }]);
    return RecordRow;
}(_react.PureComponent);

RecordRow.propTypes = {
    columns: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        id: _propTypes2.default.string.isRequired,
        format: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.func), _propTypes2.default.func]).isRequired,
        className: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.func), _propTypes2.default.func, _propTypes2.default.string]),
        cellProps: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.func), _propTypes2.default.func, _propTypes2.default.object])
    })).isRequired,
    row: _propTypes2.default.object,
    hover: _propTypes2.default.bool
};

RecordRow.defaultProps = {
    hover: true
};

exports.default = (0, _styles.withStyles)(style)(RecordRow);