'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _core = require('@material-ui/core');

var _styles = require('@material-ui/core/styles');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _RecordTableHead = require('./RecordTableHead');

var _RecordTableHead2 = _interopRequireDefault(_RecordTableHead);

var _RecordRow = require('./RecordRow');

var _RecordRow2 = _interopRequireDefault(_RecordRow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

window.renderRows = 0;
window.renderTable = 0;

var style = {
    root: {},
    tableXScroll: {
        overflowX: 'auto'
    },
    customMessageRow: {
        "& td": {
            textAlign: "center"
        }
    },
    footerRow: {},
    'cell-numeric': {
        textAlign: 'right'
    },
    'cell-button': {
        padding: 0,
        textAlign: 'center'
    },
    'cell-input': {
        // background: '#f5f5f5',
        paddingLeft: 16,
        paddingRight: 16
    }
};

var toArray = function toArray(x) {
    return x instanceof Array ? x : [x];
};
var keyBy = function keyBy(what) {
    return what === 'index' ? function (_, i) {
        return i;
    } : typeof what === 'string' ? function (row) {
        return row[what];
    } : what;
};

var RecordTable = function (_PureComponent) {
    (0, _inherits3.default)(RecordTable, _PureComponent);

    function RecordTable() {
        (0, _classCallCheck3.default)(this, RecordTable);
        return (0, _possibleConstructorReturn3.default)(this, (RecordTable.__proto__ || (0, _getPrototypeOf2.default)(RecordTable)).apply(this, arguments));
    }

    (0, _createClass3.default)(RecordTable, [{
        key: 'render',


        /** Render the table */
        value: function render() {
            var _props = this.props,
                classes = _props.classes,
                columns = _props.columns,
                data = _props.data,
                hover = _props.hover,
                keyBy = _props.keyBy,
                message = _props.message,
                onOrderChange = _props.onOrderChange,
                ordering = _props.ordering,
                style = _props.style,
                xScroll = _props.xScroll,
                includeFooter = _props.includeFooter;


            return _react2.default.createElement(
                'div',
                { className: (0, _classnames2.default)('root', (0, _defineProperty3.default)({}, classes.tableXScroll, xScroll)) },
                _react2.default.createElement(
                    _core.Table,
                    { style: style },
                    _react2.default.createElement(_RecordTableHead2.default, {
                        columns: columns,
                        ordering: ordering,
                        onOrderChange: onOrderChange
                    }),
                    _react2.default.createElement(
                        _core.TableBody,
                        { classes: {} },
                        message ? this.renderMessageRow(message, columns.length) : this.renderRows(data, columns, keyBy)
                    ),
                    includeFooter && _react2.default.createElement(
                        _core.TableFooter,
                        null,
                        this.renderFooter(data, columns)
                    )
                )
            );
        }

        /** Render all rows in data, using specified columns format */

    }, {
        key: 'renderRows',
        value: function renderRows(data, columns, keyByWhat) {
            var _this2 = this;

            window.renderRows++;
            return data.map(function (row, index) {
                return _react2.default.createElement(_RecordRow2.default, { key: keyBy(keyByWhat)(row, index), hover: _this2.props.hover, row: row, columns: columns, index: index });
            });
        }

        /** Render a row containing a specific message */

    }, {
        key: 'renderMessageRow',
        value: function renderMessageRow(message, columnSpan) {
            return _react2.default.createElement(
                _core.TableRow,
                { className: this.props.classes.customMessageRow },
                _react2.default.createElement(
                    _core.TableCell,
                    { colSpan: columnSpan },
                    message
                )
            );
        }
    }, {
        key: 'renderFooter',
        value: function renderFooter(data, columns) {
            var classes = this.props.classes;

            return _react2.default.createElement(
                _core.TableRow,
                { className: classes.footerRow },
                columns.map(function (column, index) {
                    return _react2.default.createElement(
                        _core.TableCell,
                        {
                            key: index,
                            className: toArray(column.variant).map(function (variant) {
                                return classes['cell-' + variant];
                            }).join(' ')
                        },
                        column.footer ? column.footer(data) : ''
                    );
                })
            );
        }
    }]);
    return RecordTable;
}(_react.PureComponent);

RecordTable.propTypes = {
    columns: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        id: _propTypes2.default.string.isRequired,
        label: _propTypes2.default.node,
        format: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.func), _propTypes2.default.func]).isRequired,
        sortable: _propTypes2.default.bool
        // blankDown: P.func,
    })).isRequired,
    data: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
    message: _propTypes2.default.string,
    ordering: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        id: _propTypes2.default.string,
        asc: _propTypes2.default.bool
    })).isRequired,
    xScroll: _propTypes2.default.bool,
    onOrderChange: _propTypes2.default.func,
    keyBy: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
    hover: _propTypes2.default.bool
};

RecordTable.defaultProps = {
    xScroll: true,
    hover: true,
    keyBy: function keyBy(row, index) {
        return row.id || index;
    },
    onOrderChange: function onOrderChange() {}
};

exports.default = (0, _styles.withStyles)(style)(RecordTable);