'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _core = require('@material-ui/core');

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var toArray = function toArray(x) {
    return x instanceof Array ? x : [x];
};

var mapWithKeys = function mapWithKeys(arr, fn) {
    return arr.reduce(function (obj, item) {
        return (0, _extends3.default)({}, obj, fn(item));
    }, {});
};

var style = {
    'cell-numeric': {
        textAlign: 'right'
    },
    'cell-button': {
        padding: 0,
        textAlign: 'center'
    },
    'cell-input': {
        // background: '#f5f5f5',
        paddingLeft: 16,
        paddingRight: 16
    }
    // 'cell-calculated': {
    // background: '#f5f5f5'
    // }
};

var RecordTableHead = function (_Component) {
    (0, _inherits3.default)(RecordTableHead, _Component);

    function RecordTableHead() {
        (0, _classCallCheck3.default)(this, RecordTableHead);
        return (0, _possibleConstructorReturn3.default)(this, (RecordTableHead.__proto__ || (0, _getPrototypeOf2.default)(RecordTableHead)).apply(this, arguments));
    }

    (0, _createClass3.default)(RecordTableHead, [{
        key: 'toggleColumnOrder',
        value: function toggleColumnOrder(columnId, append) {
            var _props = this.props,
                ordering = _props.ordering,
                onOrderChange = _props.onOrderChange,
                _ordering = ordering || [];

            var old = _ordering.find(function (o) {
                return o.id === columnId;
            }),
                rest = _ordering.filter(function (o) {
                return o !== old;
            }),
                defaultAsc = true;

            onOrderChange([{ id: columnId, asc: old ? !old.asc : defaultAsc }].concat((0, _toConsumableArray3.default)(append && rest ? rest : [])));
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props2 = this.props,
                columns = _props2.columns,
                ordering = _props2.ordering,
                classes = _props2.classes;

            var ordered = ordering ? mapWithKeys(ordering, function (o) {
                return (0, _defineProperty3.default)({}, o.id, o.asc);
            }) : {};
            return _react2.default.createElement(
                _core.TableHead,
                { classes: {} },
                _react2.default.createElement(
                    _core.TableRow,
                    { classes: {} },
                    columns.map(function (column) {
                        return _react2.default.createElement(
                            _core.TableCell,
                            {
                                key: column.id,
                                numeric: column.numeric || toArray(column.variant).indexOf('numeric') >= 0,
                                classes: {},
                                padding: column.narrow ? 'none' : 'default',
                                className: toArray(column.variant).map(function (variant) {
                                    return _this2.props.classes['cell-' + variant];
                                }).join(' ')
                            },
                            column.sortable ? _react2.default.createElement(
                                _core.TableSortLabel,
                                {
                                    active: column.id in ordered,
                                    direction: ordered[column.id] ? 'asc' : 'desc',
                                    onClick: function onClick(e) {
                                        return _this2.toggleColumnOrder(column.id, e.shiftKey);
                                    },
                                    classes: {}
                                },
                                column.label
                            ) : column.label
                        );
                    }, this)
                )
            );
        }
    }]);
    return RecordTableHead;
}(_react.Component);

RecordTableHead.propTypes = {
    columns: _propTypes2.default.array.isRequired,
    onOrderChange: _propTypes2.default.func.isRequired,
    // (columnId, asc (bool), shiftKey (bool)) => {}
    ordering: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        id: _propTypes2.default.string,
        asc: _propTypes2.default.bool
    })).isRequired
};

exports.default = (0, _styles.withStyles)(style)(RecordTableHead);