'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FoldSearch = require('../FoldSearch/FoldSearch');

var _FoldSearch2 = _interopRequireDefault(_FoldSearch);

var _core = require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ResourceIndexLayout = function (_PureComponent) {
    (0, _inherits3.default)(ResourceIndexLayout, _PureComponent);

    function ResourceIndexLayout() {
        (0, _classCallCheck3.default)(this, ResourceIndexLayout);
        return (0, _possibleConstructorReturn3.default)(this, (ResourceIndexLayout.__proto__ || (0, _getPrototypeOf2.default)(ResourceIndexLayout)).apply(this, arguments));
    }

    (0, _createClass3.default)(ResourceIndexLayout, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                children = _props.children,
                createUrl = _props.createUrl,
                onPageChange = _props.onPageChange,
                onPageLimitChange = _props.onPageLimitChange,
                onSearchChange = _props.onSearchChange,
                page = _props.page,
                pageLimit = _props.pageLimit,
                rowCount = _props.rowCount,
                search = _props.search,
                title = _props.title;


            return _react2.default.createElement(
                'div',
                { style: { width: '100%' } },
                _react2.default.createElement(
                    _core.Grid,
                    { container: true, spacing: 16 },
                    _react2.default.createElement(
                        _core.Grid,
                        { item: true, xs: 4 },
                        title
                    ),
                    _react2.default.createElement(
                        _core.Grid,
                        { item: true, xs: 8, style: { textAlign: 'right' } },
                        _react2.default.createElement(_FoldSearch2.default, { searchQuery: search, label: 'Search All', onChange: function onChange(f, search) {
                                return onSearchChange(search);
                            }, searchHint: 'Go search me now' }),
                        _react2.default.createElement(
                            _core.Tooltip,
                            { title: "Add another model" },
                            _react2.default.createElement(
                                _core.IconButton,
                                { color: 'secondary', href: createUrl },
                                _react2.default.createElement(
                                    _core.Icon,
                                    null,
                                    'add'
                                )
                            )
                        )
                    )
                ),
                _react2.default.createElement(
                    _core.Paper,
                    null,
                    children,
                    _react2.default.createElement(_core.TablePagination, {
                        count: rowCount,
                        labelDisplayedRows: function labelDisplayedRows(_ref) {
                            var from = _ref.from,
                                to = _ref.to,
                                count = _ref.count;
                            return from + '-' + to + ' van ' + count;
                        },
                        labelRowsPerPage: 'Rijen per pagina:',
                        onChangePage: function onChangePage(e, page) {
                            return onPageChange(parseInt(page));
                        },
                        onChangeRowsPerPage: function onChangeRowsPerPage(e) {
                            return onPageLimitChange(parseInt(e.target.value));
                        },
                        page: page,
                        rowsPerPage: pageLimit
                    })
                )
            );
        }
    }]);
    return ResourceIndexLayout;
}(_react.PureComponent);

ResourceIndexLayout.propTypes = {
    title: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.string]),
    createUrl: _propTypes2.default.string.isRequired,
    page: _propTypes2.default.number.isRequired,
    pageLimit: _propTypes2.default.number.isRequired,
    rowCount: _propTypes2.default.number.isRequired,
    search: _propTypes2.default.string.isRequired,
    onSearchChange: _propTypes2.default.func.isRequired,
    onChangePage: _propTypes2.default.func.isRequired,
    onChangePageLimit: _propTypes2.default.func.isRequired
};

exports.default = ResourceIndexLayout;