'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _core = require('@material-ui/core');

var _FormControlWrap = require('../FormControlWrap/FormControlWrap');

var _FormControlWrap2 = _interopRequireDefault(_FormControlWrap);

var _styles = require('@material-ui/core/styles');

var _optionSpec = require('../utilities/option-spec');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ClearAdornment = function ClearAdornment(_ref) {
    var onClear = _ref.onClear;
    return _react2.default.createElement(
        _core.InputAdornment,
        null,
        _react2.default.createElement(
            _core.IconButton,
            { onClick: onClear },
            _react2.default.createElement(
                _core.Icon,
                null,
                'clear'
            )
        )
    );
};

var renderOption = function renderOption(option) {
    return option.isHeader ? _react2.default.createElement(
        _core.ListSubheader,
        { component: 'div' },
        option.label
    ) : _react2.default.createElement(
        _core.MenuItem,
        { key: option.value, value: option.value, dense: true },
        option.label
    );
};

var renderFetching = function renderFetching(msg) {
    return _react2.default.createElement(
        _core.MenuItem,
        { disabled: true },
        msg
    );
};

var adornment = function adornment(body, start) {
    return _react2.default.createElement(
        _core.InputAdornment,
        { position: start ? "start" : "end" },
        body
    );
};

var style = {};

var Select = function (_Component) {
    (0, _inherits3.default)(Select, _Component);

    function Select() {
        var _ref2;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, Select);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Select.__proto__ || (0, _getPrototypeOf2.default)(Select)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
            options: [],
            fetching: false
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(Select, [{
        key: 'fetchOptions',
        value: function fetchOptions() {
            var _this2 = this;

            if (this.props.fetch) {
                this.setState({
                    fetching: true
                }, function () {
                    _this2.props.fetch().then(function (data) {
                        return _this2.setState({
                            fetching: false,
                            options: data
                        });
                    });
                });
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.fetchOptions();
        }
    }, {
        key: 'render',
        value: function render() {
            var props = this.props;

            var autoWidth = props.autoWidth,
                classes = props.classes,
                clearable = props.clearable,
                displayEmpty = props.displayEmpty,
                endAdornment = props.endAdornment,
                errors = props.errors,
                fetch = props.fetch,
                fetchMessage = props.fetchMessage,
                id = props.id,
                inputProps = props.inputProps,
                label = props.label,
                menuProps = props.menuProps,
                multiple = props.multiple,
                name = props.name,
                native = props.native,
                nativeInputProps = props.nativeInputProps,
                _onChange = props.onChange,
                options = props.options,
                renderValue = props.renderValue,
                showErrors = props.showErrors,
                startAdornment = props.startAdornment,
                value = props.value,
                withinTable = props.withinTable,
                wrapped = props.wrapped;


            var _id = id || 'i_' + name;

            var _options = fetch ? this.state.options : options;

            var _endAdornment = clearable && value.length > 0 ? _react2.default.createElement(ClearAdornment, { onClear: function onClear() {
                    return _onChange(name, multiple ? [] : '', value);
                } }) : endAdornment ? adornment(endAdornment, false) : null;

            var input = _react2.default.createElement(
                _core.Select,
                (0, _extends3.default)({
                    autoWidth: autoWidth,
                    disableUnderline: withinTable,
                    displayEmpty: displayEmpty,
                    endAdornment: _endAdornment,
                    id: _id,
                    inputProps: nativeInputProps,
                    MenuProps: menuProps,
                    multiple: multiple,
                    native: native,
                    onChange: function onChange(e) {
                        return _onChange(name, e.target.value, value);
                    },
                    renderValue: renderValue,
                    startAdornment: startAdornment ? adornment(startAdornment, true) : null,
                    value: value
                }, inputProps),
                this.state.fetching ? renderFetching(fetchMessage) : (0, _optionSpec.flattenOptionSpec)((0, _optionSpec.optionSpecToArray)(_options)).map(renderOption)
            );

            return !wrapped ? input : _react2.default.createElement(
                _FormControlWrap2.default,
                props,
                input
            );
        }
    }]);
    return Select;
}(_react.Component);

Select.propTypes = {
    autoWidth: _propTypes2.default.bool,
    clearable: _propTypes2.default.bool,
    displayEmpty: _propTypes2.default.bool,
    endAdornment: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.string]),
    errors: _propTypes2.default.arrayOf(_propTypes2.default.string),
    fetch: _propTypes2.default.func,
    fetchMessage: _propTypes2.default.string,
    inputProps: _propTypes2.default.object,
    label: _propTypes2.default.string,
    menuProps: _propTypes2.default.object,
    multiple: _propTypes2.default.bool,
    name: _propTypes2.default.string.isRequired,
    native: _propTypes2.default.bool,
    nativeInputProps: _propTypes2.default.object,
    onChange: _propTypes2.default.func.isRequired,
    options: _propTypes2.default.oneOfType([_optionSpec.pOptDict, _optionSpec.pOptList]),
    renderValue: _propTypes2.default.func,
    showErrors: _propTypes2.default.bool,
    startAdornment: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.string]),
    value: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.string), _propTypes2.default.string]),
    wrapped: _propTypes2.default.bool
};

Select.defaultProps = {
    wrapped: true,
    fetchMessage: 'Bezig met laden...',
    fullWidth: true
};

exports.default = (0, _styles.withStyles)(style)(Select);