'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('@material-ui/core/styles');

var _core = require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var flattenItems = function flattenItems(list) {
    return _lodash2.default.flatMap(list, function (item) {
        return item.items ? [(0, _extends3.default)({ isHeader: true }, item)].concat((0, _toConsumableArray3.default)(flattenItems(item.items))) : item;
    });
};

var drawerWidth = 240;

var styles = {
    root: {
        position: 'relative',
        width: drawerWidth,
        justifyContent: 'space-between'
    },
    secondaryMenu: {
        justifySelf: 'flex-end'
    }
};

var Sidebar = function Sidebar(_ref) {
    var classes = _ref.classes,
        compact = _ref.compact,
        onCloseSidebar = _ref.onCloseSidebar,
        open = _ref.open,
        primaryItems = _ref.primaryItems,
        secondaryItems = _ref.secondaryItems;
    return _react2.default.createElement(
        _core.Drawer,
        {
            anchor: 'left',
            classes: { paper: classes.root },
            onClose: onCloseSidebar,
            open: open,
            variant: 'persistent'
        },
        _react2.default.createElement(
            _core.List,
            { className: classes.primaryMenu },
            flattenItems(primaryItems).map(function (_ref2, index) {
                var isHeader = _ref2.isHeader,
                    label = _ref2.label,
                    active = _ref2.active,
                    onClick = _ref2.onClick,
                    icon = _ref2.icon;
                return _react2.default.createElement(
                    'div',
                    { key: index },
                    isHeader ? _react2.default.createElement(
                        _core.ListSubheader,
                        null,
                        label
                    ) : _react2.default.createElement(
                        _core.MenuItem,
                        { selected: active, onClick: onClick },
                        !icon ? '' : _react2.default.createElement(
                            _core.ListItemIcon,
                            null,
                            _react2.default.createElement(
                                _core.Icon,
                                null,
                                icon
                            )
                        ),
                        compact ? '' : label
                    )
                );
            })
        ),
        _react2.default.createElement(
            _core.List,
            { className: classes.secondaryMenu },
            _react2.default.createElement(_core.Divider, null),
            secondaryItems.map(function (_ref3, index) {
                var label = _ref3.label,
                    icon = _ref3.icon,
                    onClick = _ref3.onClick;
                return _react2.default.createElement(
                    _core.MenuItem,
                    { button: true, onClick: onClick, key: index },
                    !icon ? '' : _react2.default.createElement(
                        _core.ListItemIcon,
                        null,
                        _react2.default.createElement(
                            _core.Icon,
                            null,
                            icon
                        )
                    ),
                    compact ? '' : label
                );
            })
        )
    );
};

Sidebar.propTypes = {
    classes: _propTypes2.default.object,
    compact: _propTypes2.default.bool,
    onCloseSidebar: _propTypes2.default.func.isRequired,
    open: _propTypes2.default.bool,
    primaryItems: _propTypes2.default.array.isRequired,
    secondaryItems: _propTypes2.default.array.isRequired
};

Sidebar.defaultProps = {
    compact: false,
    primaryItems: [],
    secondaryItems: []
};

exports.default = (0, _styles.withStyles)(styles)(Sidebar);