'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _core = require('@material-ui/core');

var _FormControlWrap = require('../FormControlWrap/FormControlWrap');

var _FormControlWrap2 = _interopRequireDefault(_FormControlWrap);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ClearAdornment = function ClearAdornment(_ref) {
    var onClear = _ref.onClear;
    return _react2.default.createElement(
        _core.InputAdornment,
        null,
        _react2.default.createElement(
            _core.IconButton,
            { onClick: onClear },
            _react2.default.createElement(
                _core.Icon,
                null,
                'clear'
            )
        )
    );
};

var adornment = function adornment(body, start) {
    return _react2.default.createElement(
        _core.InputAdornment,
        { position: start ? "start" : "end" },
        body
    );
};

var style = {
    withinTableError: {
        background: '#ffe6e6'
    }
};

var TextField = function TextField(props) {
    var autoFocus = props.autoFocus,
        classes = props.classes,
        clearable = props.clearable,
        endAdornment = props.endAdornment,
        errors = props.errors,
        fullWidth = props.fullWidth,
        helperText = props.helperText,
        id = props.id,
        inputProps = props.inputProps,
        label = props.label,
        margin = props.margin,
        name = props.name,
        nativeInputProps = props.nativeInputProps,
        _onChange = props.onChange,
        parse = props.parse,
        placeholder = props.placeholder,
        required = props.required,
        rows = props.rows,
        showErrors = props.showErrors,
        startAdornment = props.startAdornment,
        type = props.type,
        value = props.value,
        wrapped = props.wrapped,
        withinTable = props.withinTable;


    var _id = id || 'i_' + name;

    var _endAdornment = clearable && value.length > 0 ? _react2.default.createElement(ClearAdornment, { onClear: function onClear() {
            return _onChange(name, '', value);
        } }) : endAdornment ? adornment(endAdornment, false) : null;

    var _type = type === 'integer' ? 'number' : type;

    var _parse = parse ? parse : type === 'integer' ? parseInt : type === 'number' ? parseFloat : function (id) {
        return id;
    };

    var input = _react2.default.createElement(_core.Input, (0, _extends3.default)({
        autoFocus: autoFocus,
        endAdornment: _endAdornment,
        classes: { error: withinTable ? classes.withinTableError : '' },
        error: showErrors,
        disableUnderline: withinTable,
        fullWidth: fullWidth,
        id: _id,
        inputProps: nativeInputProps,
        margin: margin,
        multiline: type === 'textarea',
        name: name,
        onChange: function onChange(_ref2) {
            var target = _ref2.target;
            return _onChange(name, _parse(target.value), value);
        },
        placeholder: placeholder,
        rows: rows,
        startAdornment: startAdornment ? adornment(startAdornment, true) : null,
        type: _type,
        value: value
    }, inputProps));

    var wrapProps = (0, _extends3.default)({}, props, {
        classes: {}
    });

    return !wrapped ? input : _react2.default.createElement(
        _FormControlWrap2.default,
        wrapProps,
        input
    );
};

TextField.propTypes = {
    autoFocus: _propTypes2.default.bool,
    clearable: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    endAdornment: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.string]),
    errors: _propTypes2.default.arrayOf(_propTypes2.default.string),
    formControlProps: _propTypes2.default.object,
    fullWidth: _propTypes2.default.bool,
    helperText: _propTypes2.default.string,
    id: _propTypes2.default.string,
    inputProps: _propTypes2.default.object,
    inputLabelProps: _propTypes2.default.object,
    label: _propTypes2.default.string,
    margin: _propTypes2.default.oneOf(['dense', 'none']),
    name: _propTypes2.default.string.isRequired,
    nativeInputProps: _propTypes2.default.object,
    onChange: _propTypes2.default.func.isRequired,
    parse: _propTypes2.default.func,
    placeholder: _propTypes2.default.string,
    required: _propTypes2.default.bool,
    rows: _propTypes2.default.number,
    showErrors: _propTypes2.default.bool,
    startAdornment: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.string]),
    type: _propTypes2.default.oneOf(['date', 'datetime-local', 'email', 'integer', 'month', 'number', 'password', 'search', 'text', 'time', 'week', 'textarea']),
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    wrapped: _propTypes2.default.bool,
    withinTable: _propTypes2.default.bool
};

TextField.defaultProps = {
    type: 'text',
    wrapped: true,
    fullWidth: true
};

exports.default = (0, _styles.withStyles)(style)(TextField);