'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** Create an object with properties for specified input fields */
function createInputProps(formData, _ref, fields) {
  var _onChange = _ref.onChange,
      onFieldTouch = _ref.onFieldTouch;


  return (0, _entries2.default)(fields).reduce(function (propSheet, _ref2) {
    var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
        fieldName = _ref3[0],
        field = _ref3[1];

    var data = formData.data,
        _formData$fields$fiel = formData.fields[fieldName],
        original = _formData$fields$fiel.original,
        touched = _formData$fields$fiel.touched,
        errors = formData.errors[fieldName] || [],
        dirty = data[fieldName] !== original;


    var props = {};
    switch (field.type) {

      case 'radio':
        props = field.values.map(function (value) {
          return (0, _extends4.default)({
            name: fieldName,
            value: data[fieldName]
          }, field);
        });
        break;

      case 'check':
        props = (0, _extends4.default)({
          name: fieldName,
          value: data[fieldName]
        }, field);
        break;

      default:
        props = (0, _extends4.default)({
          name: fieldName,
          showErrors: (touched || dirty || formData.show_errors) && errors.length > 0,
          onChange: function onChange(newValue) {
            return _onChange(fieldName, newValue);
          },
          value: data[fieldName],
          errors: errors,
          labelUp: field.multiline || field.type === 'date',
          placeholder: field.title,
          onBlur: function onBlur() {
            return onFieldTouch(fieldName);
          }
        }, field);
    }

    return (0, _extends4.default)({}, propSheet, (0, _defineProperty3.default)({}, fieldName, props));
  }, {});
}
exports.default = createInputProps;