"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var memoize = exports.memoize = function memoize(fn) {
    var cache = [];
    var result = null;
    var first = true;
    return function () {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var same = !first && cache.length === args.length && cache.reduce(function (isEq, v, k) {
            return isEq && v === args[k];
        }, true);

        result = same ? result : fn.apply(undefined, args);
        cache = args;
        first = false;
        return result;
    };
};

exports.default = memoize;