'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.deepRead = exports.write = exports.writeSingle = exports.replaceDeep = exports.replace = undefined;

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var replace = exports.replace = function replace(objectOrArray, index, target) {
    return objectOrArray instanceof Array ? objectOrArray.map(function (value, key) {
        return key == index ? target : value;
    }) : (0, _extends5.default)({}, objectOrArray, (0, _defineProperty3.default)({}, index, target));
};

var replaceDeep = exports.replaceDeep = function replaceDeep(objectOrArray, indices, target) {
    var _ref = typeof indices === 'string' ? indices.split(/\.|\[|\]\.|\]/) : indices,
        _ref2 = (0, _toArray3.default)(_ref),
        head = _ref2[0],
        tail = _ref2.slice(1);

    return tail.length === 0 ? replace(objectOrArray, head, target) : replace(objectOrArray, head, replaceDeep(objectOrArray[head], tail, target));
};

/*

a.b.c.d => 10

replace(a.b.c, d, 10)
replace(a.b, c, replace(c, d, 10))
replace(a, b, replace(b, c, replace(c, 10)))

*/

/** Write a value at a position in an object */
var writeSingle = exports.writeSingle = function writeSingle(object, keys, transform) {
    var _keys = (0, _toArray3.default)(keys),
        head = _keys[0],
        tail = _keys.slice(1);

    return (0, _extends5.default)({}, object, (0, _defineProperty3.default)({}, head, tail.length === 0 ? transform(object[head]) : writeSingle(object[head] || {}, tail, transform)));
};

var write = exports.write = function write(state, transforms) {
    return transforms.reduce(function (s, transform) {
        return writeSingle(s, transform.slice(0, -1), transform.slice(-1));
    }, state);
};

var deepRead = exports.deepRead = function deepRead(object, keys) {
    var _keys2 = (0, _toArray3.default)(keys),
        head = _keys2[0],
        tail = _keys2.slice(1);

    if (!object[head]) return null;
    return tail ? deepRead(object[head] || {}, tail) : object[head];
};