"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.pOptList = exports.pOptDict = exports.flattenOptionSpec = exports.optionSpecToArray = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** Normalize an Options Dictionary to an array */
var optionSpecToArray = exports.optionSpecToArray = function optionSpecToArray(options) {
    return options instanceof Array ?
    // Normalize nested options as well
    options.map(function (o) {
        return !o.options ? o : (0, _extends3.default)({}, o, { options: optionSpecToArray(o.options) });
    }) : _lodash2.default.map(options, function (valueOrOptions, label) {
        return (typeof valueOrOptions === "undefined" ? "undefined" : (0, _typeof3.default)(valueOrOptions)) === 'object' ? { label: label, options: optionSpecToArray(valueOrOptions) } : { label: label, value: valueOrOptions };
    });
};

/** Flatten a tree to a flat array with .level prop */
var flattenOptionSpec = exports.flattenOptionSpec = function flattenOptionSpec(options) {
    var level = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    return _lodash2.default.flatMap(options, function (option) {
        return option.options ? [{ label: option.label, isHeader: true, level: level }].concat((0, _toConsumableArray3.default)(flattenOptionSpec(option.options, level + 1))) : [(0, _extends3.default)({}, option, { level: level })];
    });
};

// Lazy Evaluation needed for recursive prop-type references
function lazy(f) {
    return function () {
        return f.apply(this, arguments);
    };
}

// Custom Types for the options specification
var pOptDict = exports.pOptDict = lazy(function () {
    return _propTypes2.default.objectOf(_propTypes2.default.oneOfType([_propTypes2.default.string, pOptDict]));
});

var pOptList = exports.pOptList = lazy(function () {
    return _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([
    // Leaf
    _propTypes2.default.shape({
        label: _propTypes2.default.string,
        value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool, _propTypes2.default.number])
    }),
    // Node
    _propTypes2.default.shape({
        label: _propTypes2.default.string,
        options: pOptList
    })]));
});